; **********************************************************
; RDUCT.LSP
; Copyright (c) Barry R. Bowen 1993
; ----------------------------------------------------------

(defun C:RDUCT (/ ANS ANG ANG1 ANG2 ANG3 DANG DH DW DU HDW MPT1
      MPT2 PT1 PT1D CPT CP1 CP2 CPT1 CPT2 CPT3 CPT4 REP TH HW
      HMPT TANG L1 L2 PT1C PT1B PT2 PT3 PT4 NWW WWB WWD DTYP)
  (V3)
  (if (not TRA) (setq TRA
      (getangle "\nTransition Angle<15> <20> <30>: ")))
  (initget 1 "R O")
  (setq DTYP (getkword "\n<R>ectangular Or R<O>und Duct: "))
  (NBEGIN) (RL) (V4)
)

(defun C:TRANG ()
  (setq TRA (getangle "\nTransition Angle<15> <20> <30>: ")))

(defun NBEGIN ()
  (command "undo" "m")
  (if (= DTYP "O") (progn
      (initget 1 "C E X")
      (setq ANS (getkword "\n<C>enter/e<X>it: ")))
    (progn
      (initget 1 "C E X")
      (setq ANS (getkword "\n<C>enter/<E>dge/e<X>it: "))
  ) )
  (if (/= ANS "X") (progn
    (if (/= DW nil) (setq DU DW) (setq DU 12))
    (initget (+ 2 4))
    (setq DW (getint (strcat "\nDuct Width <" (itoa DU) ">: ")))
    (if (not DW) (setq DW DU))
    (if (/= DTYP "O") (progn
       (initget (+ 2 4))
       (setq DH (getint (strcat "\nDepth <" (itoa DW) ">: ")))
    ))
    (if (not DH) (setq DH DW))
    (setq HDW (/ DW 2.0))
  ))
  (cond ((= ANS "C") (CNT))
        ((= ANS "E") (EDG))
        ((= ANS "O") (CNT))
        (T (setq ANS nil)))
)

(defun EDG ()
  (LS "M-HVAC-DUCT" "3" "")
  (command "undo" "m")
  (setq PT1 (getpoint "\nBegining Point: ")
        PT2 (getpoint PT1 "\nEndpoint: "))
  (grdraw PT1 PT2 1)
  (setq ANG (getangle PT2 "\nSide: ")
        PT3 (polar PT1 ANG DW)
        PT4 (polar PT2 ANG DW)
       DANG (angle PT1 PT2))
  (command "pline" PT1 "w" 0 0 PT2 PT4 PT3 "")
  (ADDSIZE) (NEXT)
  (initget "C T X")
  (setq ANS (getkword "\n<C>ontinue, <T>urn, e<X>it: "))
  (cond ((= ANS "C") (NEXT))
        ((= ANS "T") (TURN) (NBEGIN))
        (T (setq ANS nil))
) )

(defun NEXT ()
  (LS "M-HVAC-DUCT" "3" "")
  (command "undo" "m")
  (setq PT1 PT2 PT3 PT4)
  (initget (+ 2 4))
  (setq NWW (getint "\nNext Duct Width: "))
  (while (/= NWW NIL)
   (if (/= DTYP "O") (progn
     (initget (+ 2 4))
     (SETQ DH (getint (strcat "\nDepth <" (itoa NWW) ">: ")))
   ))
     (if (not DH) (setq DH NWW))
     (if (< NWW DW) (reduce) (cont))
     (setq PT1 PT2 PT3 PT4)
     (initget (+ 2 4))
     (setq NWW (getint "\nNext Duct Width: "))
) )

(defun NPT () (setq PT1C (polar PT3 ANG3 (/ WWD (sin TRA)))))

(defun NPT1 () (setq PT1C (polar PT3 ANG2 (/ WWD (- (sin TRA))))))

(defun REDUCE ()
 (LS "M-HVAC-DUCT" "3" "")
 (command "undo" "m")
 (setq PT2 (getpoint PT1 "\nNext point: ")
      ANG2 (- (angle PT1 PT2) TRA)
      ANG3 (+ (ANGLE PT1 PT2) TRA)
       WWB (* NWW 0.5) WWD (- WWB HDW)
      ANG1 (angle PT1 PT2)
       PT4 (polar PT2 ANG NWW))
 (cond
   ((and (= ANG1 0) (> ANG 4.0)) (NPT))
   ((and (= ANG1 0) (< ANG 2.0)) (NPT1))
   ((and (= ANG1 pi) (< ANG 2.0)) (NPT))
   ((and (= ANG1 pi) (> ANG 4.0)) (NPT1))
   ((and (= ANG1 (D90)) (= ANG 0)) (NPT))
   ((and (= ANG1 (D90)) (= ANG pi)) (NPT1))
   ((and (= ANG1 (D270)) (= ANG 0)) (NPT1))
   ((and (= ANG1 (D270)) (= ANG pi)) (NPT))
 )
 (setq PT1B (polar PT1 ANG NWW)
      PT1C (inters PT3 PT1C PT4 PT1B nil)
      PT1D (polar PT1C (angle PT4 PT2) NWW))
 (command "Pline" PT1 PT1D PT1C PT3 "")
 (command "pline" PT1D PT2 PT4 PT1C "")
 (setq PT1 PT1D PT3 PT1C HDW WWB DW NWW)
 (ADDSIZE)
)

(defun CNT ()
  (LS "M-HVAC-DUCT" "3" "")
  (command "undo" "m")
  (setq MPT1 (getpoint "\nCenterline First Point: ")
        MPT2 (getpoint MPT1 "\nEndpoint: ")
        DANG (angle MPT1 MPT2)
         ANG (+ DANG (D90))
         PT1 (polar MPT1 (+ ANG pi) HDW)
         PT3 (polar PT1 ANG DW))
  (ENLAR)
  (initget "C T X")
  (setq ANS (getkword "\n<C>ontinue, <T>urn, e<X>it: "))
  (cond ((= ANS "C") (NBEGIN))
        ((= ANS "T") (TURN) (NBEGIN))
        (T (setq ANS nil))
) )

(defun RED1 ()
  (LS "M-HVAC-DUCT" "3" "")
  (command "undo" "m")
  (setq MPT2 (getpoint MPT1 "\nNext Point: ")
        DANG (angle MPT1 MPT2)
        ANG3 (+ (angle MPT1 MPT2) TRA)
        ANG2 (- (angle MPT1 MPT2) TRA)
         WWB (* NWW 0.5)
         ANG (+ (angle MPT1 MPT2) (* pi 0.5)))
  (if (< NWW DW)
    (progn
      (setq WWD (- HDW WWB)
           PT1D (polar PT3 ANG2 (/ WWD (sin TRA)))
           PT1C (polar PT1 ANG3 (/ WWD (sin TRA))))
    )
    (progn
      (setq WWD (- WWB HDW)
           PT1D (polar PT3 ANG3 (/ WWD (sin TRA)))
           PT1C (polar PT1 ANG2 (/ WWD (sin TRA))))
  ) )
  (setq PT2 (polar MPT2 (+ ANG pi) WWB)
       PT2A (polar PT2 ANG NWW))
  (grdraw MPT1 MPT2 1)
  (command "Pline" PT3 PT1D PT1C PT1 "")
  (setq MPT1 (polar PT1C ANG WWB)
        PT1 PT1C PT3 PT1D HDW WWB DW NWW)
  (ENLAR)
)

(defun ENLAR ()
  (LS "M-HVAC-DUCT" "3" "")
  (command "undo" "m")
  (grdraw MPT1 MPT2 1)
  (setq ANG (+ (angle MPT1 MPT2) (* pi 0.5))
      DANG (angle MPT1 MPT2)
      PT2 (polar MPT2 (+ ANG pi) HDW)
      PT4 (polar PT2 ANG DW))
  (command "Pline" PT1 PT2 PT4 PT3 "")
  (ADDSIZE)
  (setq MPT1 MPT2 PT1 PT2 PT3 PT4)
  (setvar "blipmode" 0)
  (initget (+ 2 4))
  (setq NWW (getint "\nNext Duct Width: "))
  (IF (/= NWW NIL)
   (PROGN
   (if (/= DTYP "O")
     (SETQ DH (getint (strcat "\nDepth <" (itoa NWW) ">: ")))
   )
   (if (not DH) (setq DH NWW))
   (RED1)
  ))
)

(defun TURN ()
  (LS "M-HVAC-DUCT" "3" "")
  (command "undo" "m")
  (if (= DTYP "O") (setq ANS "R")
   (progn
    (initget 1 "R S")
    (setq ANS (getkword "\n<R>adius or <S>quare: "))
  ))
  (setq NANG (getangle PT2 "\nDirection: ")
        ANG1 (angle PT2 PT4))
  (if (= ANS "S")
   (progn
   (if (/= NANG ANG1)
    (progn
      (setq CPT1 (polar PT4 DANG (+ 6.0 DW))
            CPT4 (polar PT1 DANG 6.0)
            CPT2 (polar CPT1 NANG (+ 6.0 DW))
            CPT3 (polar CPT4 NANG 6.0))
      (command "pline" PT4 CPT1 CPT2 CPT3 CPT4 PT1 "")
    )
    (progn
      (setq CPT1 (polar PT1 DANG (+ 6.0 DW))
            CPT4 (polar PT4 DANG 6.0)
            CPT2 (polar CPT1 NANG (+ 6.0 DW))
            CPT3 (polar CPT4 NANG 6.0))
      (command "pline" PT1 CPT1 CPT2 CPT3 CPT4 PT4 "")
    ))
  ))
  (if (= ANS "R") (progn
      (if (/= NANG ANG1)
        (progn
          (setq CPT (polar PT2 NANG DW)
                CP1 (polar CPT DANG DW)
                CP2 (polar CPT DANG (* DW 2)))
          (command "arc" "C" CPT CP1 PT2)
          (setq L1 (entlast))
          (command "arc" "C" CPT CP2 PT4)
          (setq L2 (entlast))
          (command "line" CP1 CP2 "")
          (setq REP (strcase (getstring "\nIs This Correct <Y>: ")))
          (if (and (/= REP "") (/= REP "Y"))
            (progn
              (command "erase" L1 L2 "")
              (command "arc" "C" CPT PT2 CP1)
              (command "arc" "C" CPT PT4 CP2)
          ))
          (setq PT2 CP1 PT4 CP2)
        )
        (progn
          (setq CPT (polar PT4 NANG DW)
                CP1 (polar CPT DANG DW)
                CP2 (polar CPT DANG (* DW 2)))
          (command "arc" "C" CPT PT2 CP1)
          (setq L1 (entlast))
          (command "arc" "C" CPT PT4 CP2)
          (setq L2 (entlast))
          (command "line" CP1 CP2 "")
          (setq REP (strcase (getstring "\nIs This Correct <Y>: ")))
          (if (and (/= REP "") (/= REP "Y"))
            (progn
              (command "erase" L1 L2 "")
              (command "arc" "C" CPT CP1 PT2)
              (command "arc" "C" CPT CP2 PT4)
          ))
          (setq PT2 CP1 PT4 CP2)
        )
      )
    )
  )
)

(defun ADDSIZE ()
  (LS "M-HVAC-NOTE" "" "")
  (command "undo" "m")

;;  (setq TH (getvar "textsize"))
  (setq TH (* (getvar "dimscale") (getvar "dimtxt")))

  (setq HW (RTOS DW 2 0))
  (if (/= DTYP "O") (setq DH (RTOS DH 2 0)))
  (if (= ANS "E")
      (progn
        (setq HMPT (polar PT1 (angle PT1 PT2) (/ (distance PT1 PT2) 2)))
        (setq MPT (polar HMPT ANG HDW))
      )
      (setq MPT (polar MPT1 (angle MPT1 MPT2)
                (/ (distance MPT1 MPT2) 2)))
  )
  (setq TANG (angle PT1 PT2))
  (if (= TANG pi) (setq TANG 0))
  (if (= TANG (* pi 1.5)) (setq TANG (* pi 0.5)))
  (if (/= DTYP "O")
    (command "text" "m" MPT TH 0 (strcat HW "/" DH))
;;  (command "text" "m" MPT TH (ANGTOS TANG) (strcat HW "/" DH))
    (command "text" "m" MPT TH 0 (strcat HW (chr 34) "%%c" ))
  )
)

(defun CONT ()
 (LS "M-HVAC-DUCT" "3" "")
 (command "undo" "m")
 (setq PT2 (getpoint PT1 "\nNext point: ")
       ANG3 (- (angle PT1 PT2) TRA)
       ANG2 (+ (ANGLE PT1 PT2) TRA)
       WWB (* NWW 0.5)
        WWD (- WWB HDW)
       PT4 (polar PT2 ANG NWW))
  (IF (< ANG 2.0)
      (SETQ PT1C (polar PT3 ANG2 (/ WWD (- (sin TRA)))))
      (SETQ PT1C (POLAR PT3 ANG3 (/ WWD (sin TRA)))))
  (SETQ PT1B (POLAR PT1 ANG NWW)
       PT1C (INTERS PT3 PT1C PT4 PT1B NIL)
       PT1D (polar PT1C (angle PT4 PT2) NWW))
  (command "Pline" PT1 PT1D PT1C PT3 "")
  (command "pline" PT1D PT2 PT4 PT1C "")
  (setq PT1 PT1D PT3 PT1C HDW WWB DW NWW)
  (ADDSIZE)
)

(defun D90 () (* pi 0.5))
(defun D270 () (* pi 1.5))

(defun V3 ()
  (setq BM (getvar "blipmode"))
  (setvar "orthomode" 1)
  (setvar "blipmode" 0)
  (setvar "cmdecho" 0)
 )

(defun V4 (/ BA)
  (setvar "blipmode" BM)
  (prompt "\n")
  (setq BA "Program Completed. . . . .")
)

(defun LS (NLAY CLR LT)
 (setq CL (getvar "clayer"))
 (setq LAY (tblsearch "layer" NLAY))
 (if (not LAY)
   (command "layer" "m" NLAY "c" CLR "" "lt" LT "" "");True
    (progn
      (setq FRZ (cdr (assoc 70 LAY)))
      (if (= FRZ 65)
        (progn
         (command "layer" "t" NLAY "")
         (command "layer" "s" NLAY "")
        )
         (command "layer" "s" NLAY "") ;False
))  ) )

(defun RL () (command "layer" "s" CL ""))

(prompt " RDuct Program Loaded!")
(prompt "\nType RDUCT at the AutoCAD Command: Prompt")
(prompt "\nCopyright (c) Barry R. Bowen 1993")
(princ)

